## javax.servlet.http
Class HttpServletRequestWrapper

    java.lang.Object
      javax.servlet.ServletRequestWrapper
          javax.servlet.http.HttpServletRequestWrapper

All Implemented Interfaces:
  HttpServletRequest, ServletRequest

    public class HttpServletRequestWrapper

extends ServletRequestWrapper
implements HttpServletRequest

Provides a convenient implementation of the HttpServletRequest interface that can be subclassed by developers wishing to adapt the request to a Servlet.

This class implements the Wrapper or Decorator pattern. Methods default to calling through to the wrapped request object.

Since:
  Servlet 2.3
See Also:
  `HttpServletRequest`

Field Summary

Fields inherited from interface javax.servlet.http.HttpServletRequest
`BASIC_AUTH, CLIENT_CERT_AUTH, DIGEST_AUTH, FORM_AUTH`

Constructor Summary
`HttpServletRequestWrapper(HttpServletRequest request)` Constructs a request object wrapping the given request.

Method Summary
`boolean` `authenticate(HttpServletResponse response)` The default behavior of this method is to call authenticate on the wrapped request object.
`String` `getAuthType()` The default behavior of this method is to return getAuthType() on the wrapped request object.
`String` `getContextPath()` The default behavior of this method is to return getContextPath() on the wrapped request object.
`Cookie[]` `getCookies()` The default behavior of this method is to return getCookies() on the wrapped request object.
`long` `getDateHeader(String name)` The default behavior of this method is to return getDateHeader(String name) on the wrapped request object.
`String` `getHeader(String name)` The default behavior of this method is to return getHeader(String name) on the wrapped request object.
`Enumeration<String>` `getHeaderNames()` The default behavior of this method is to return getHeaderNames() on the wrapped request object.
`Enumeration<String>` `getHeaders(String name)` The default behavior of this method is to return getHeaders(String name) on the wrapped request object.
`int` `getIntHeader(String name)` The default behavior of this method is to return getIntHeader(String name) on the wrapped request object.
`String` `getMethod()` The default behavior of this method is to return getMethod() on the wrapped request object.
`Part` `getPart(String name)` The default behavior of this method is to call getPart on the wrapped request object.
`Collection<Part>` `getParts()` The default behavior of this method is to call getParts on the wrapped request object.
`String` `getPathInfo()` The default behavior of this method is to return getPathInfo() on the wrapped request object.
`String` `getPathTranslated()` The default behavior of this method is to return getPathTranslated() on the wrapped request object.
`String` `getQueryString()` The default behavior of this method is to return getQueryString() on the wrapped request object.
`String` `getRemoteUser()` The default behavior of this method is to return getRemoteUser() on the wrapped request object.
`String` `getRequestedSessionId()` The default behavior of this method is to return getRequestedSessionId() on the wrapped request object.
`String` `getRequestURI()` The default behavior of this method is to return getRequestURI() on the wrapped request object.
`StringBuffer` `getRequestURL()` The default behavior of this method is to return getRequestURL() on the wrapped request object.
`String` `getServletPath()` The default behavior of this method is to return getServletPath() on the wrapped request object.
`HttpSession` `getSession()` The default behavior of this method is to return getSession() on the wrapped request object.
`HttpSession` `getSession(boolean create)` The default behavior of this method is to return getSession(boolean create) on the wrapped request object.
`Principal` `getUserPrincipal()` The default behavior of this method is to return getUserPrincipal() on the wrapped request object.
`boolean` `isRequestedSessionIdFromCookie()` The default behavior of this method is to return isRequestedSessionIdFromCookie() on the wrapped request object.
`boolean` `isRequestedSessionIdFromUrl()` The default behavior of this method is to return isRequestedSessionIdFromUrl() on the wrapped request object.
`boolean` `isRequestedSessionIdFromURL()` The default behavior of this method is to return isRequestedSessionIdFromURL() on the wrapped request object.
`boolean` `isRequestedSessionIdValid()` The default behavior of this method is to return isRequestedSessionIdValid() on the wrapped request object.
`boolean` `isUserInRole(String role)` The default behavior of this method is to return isUserInRole(String role) on the wrapped request object.
`void` `login(String username, String password)` The default behavior of this method is to call login on the wrapped request object.
`void` `logout()` The default behavior of this method is to call login on the wrapped request object.
`void` `upgrade(ProtocolHandler handler)` Notifies the servlet container that the given ProtcolHandler would be used to upgrade the request.

Methods inherited from class javax.servlet.ServletRequestWrapper

`getAsyncContext, getAttribute, getAttributeNames, getCharacterEncoding, getContentLength, getContentLengthLong, getContentType, getDispatcherType, getInputStream, getLocalAddr, getLocale, getLocales, getLocalName, getLocalPort, getParameter, getParameterMap, getParameterNames, getParameterValues, getProtocol, getReader, getRealPath, getRemoteAddr, getRemoteHost, getRemotePort, getRequest, getRequestDispatcher, getScheme, getServerName, getServerPort, getServletContext, isAsyncStarted, isAsyncSupported, isSecure, isWrapperFor, isWrapperFor, removeAttribute, setAttribute, setCharacterEncoding, setRequest, startAsync, startAsync`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface javax.servlet.ServletRequest

`getAsyncContext, getAttribute, getAttributeNames, getCharacterEncoding, getContentLength, getContentLengthLong, getContentType, getDispatcherType, getInputStream, getLocalAddr, getLocale, getLocales, getLocalName, getLocalPort, getParameter, getParameterMap, getParameterNames, getParameterValues, getProtocol, getReader, getRealPath, getRemoteAddr, getRemoteHost, getRemotePort, getRequestDispatcher, getScheme, getServerName, getServerPort, getServletContext, isAsyncStarted, isAsyncSupported, isSecure, removeAttribute, setAttribute, setCharacterEncoding, startAsync, startAsync`

Constructor Detail

### HttpServletRequestWrapper

    public HttpServletRequestWrapper(HttpServletRequest request)

  Constructs a request object wrapping the given request.

  Throws:
    `IllegalArgumentException` - if the request is null

Method Detail

### getAuthType

    public String getAuthType()

  The default behavior of this method is to return getAuthType() on the wrapped request object.

  Specified by:
    `getAuthType` in interface `HttpServletRequest`
  Returns:
    one of the static members BASIC_AUTH, FORM_AUTH, CLIENT_CERT_AUTH, DIGEST_AUTH (suitable for == comparison) or the container-specific string indicating the authentication scheme, or `null` if the request was not authenticated.

### getCookies

    public Cookie[] getCookies()

  The default behavior of this method is to return getCookies() on the wrapped request object.

  Specified by:
    `getCookies` in interface `HttpServletRequest`
  Returns:
    an array of all the `Cookies` included with this request, or `null` if the request has no cookies

### getDateHeader

    public long getDateHeader(String name)

  The default behavior of this method is to return getDateHeader(String name) on the wrapped request object.

  Specified by:
    `getDateHeader` in interface `HttpServletRequest`
  Parameters:
    `name` - a `String` specifying the name of the header
  Returns:
    a `long` value representing the date specified in the header expressed as the number of milliseconds since January 1, 1970 GMT, or -1 if the named header was not included with the request

### getHeader

    public String getHeader(String name)

  The default behavior of this method is to return getHeader(String name) on the wrapped request object.

  Specified by:
    `getHeader` in interface `HttpServletRequest`
  Parameters:
    `name` - a `String` specifying the header name
  Returns:
    a `String` containing the value of the requested header, or `null` if the request does not have a header of that name

### getHeaders

    public Enumeration<String> getHeaders(String name)

  The default behavior of this method is to return getHeaders(String name) on the wrapped request object.

  Specified by:
    `getHeaders` in interface `HttpServletRequest`
  Parameters:
    `name` - a `String` specifying the header name
  Returns:
    an `Enumeration` containing the values of the requested header. If the request does not have any headers of that name return an empty enumeration. If the container does not allow access to header information, return null

### getHeaderNames

    public Enumeration<String> getHeaderNames()

  The default behavior of this method is to return getHeaderNames() on the wrapped request object.

  Specified by:
    `getHeaderNames` in interface `HttpServletRequest`
  Returns:
    an enumeration of all the header names sent with this request; if the request has no headers, an empty enumeration; if the servlet container does not allow servlets to use this method, `null`

### getIntHeader

    public int getIntHeader(String name)

  The default behavior of this method is to return getIntHeader(String name) on the wrapped request object.

  Specified by:
    `getIntHeader` in interface `HttpServletRequest`
  Parameters:
    `name` - a `String` specifying the name of a request header
  Returns:
    an integer expressing the value of the request header or -1 if the request doesn't have a header of this name

### getMethod

    public String getMethod()

  The default behavior of this method is to return getMethod() on the wrapped request object.

  Specified by:
    `getMethod` in interface `HttpServletRequest`
  Returns:
    a `String` specifying the name of the method with which this request was made

### getPathInfo

    public String getPathInfo()

  The default behavior of this method is to return getPathInfo() on the wrapped request object.

  Specified by:
    `getPathInfo` in interface `HttpServletRequest`
  Returns:
    a `String`, decoded by the web container, specifying extra path information that comes after the servlet path but before the query string in the request URL; or `null` if the URL does not have any extra path information

### getPathTranslated

    public String getPathTranslated()

  The default behavior of this method is to return getPathTranslated() on the wrapped request object.

  Specified by:
    `getPathTranslated` in interface `HttpServletRequest`
  Returns:
    a `String` specifying the real path, or `null` if the URL does not have any extra path information

### getContextPath

    public String getContextPath()

  The default behavior of this method is to return getContextPath() on the wrapped request object.

  Specified by:
    `getContextPath` in interface `HttpServletRequest`
  Returns:
    a `String` specifying the portion of the request URI that indicates the context of the request
  See Also:
    `ServletContext.getContextPath()`

### getQueryString

    public String getQueryString()

  The default behavior of this method is to return getQueryString() on the wrapped request object.

  Specified by:
    `getQueryString` in interface `HttpServletRequest`
  Returns:
    a `String` containing the query string or `null` if the URL contains no query string. The value is not decoded by the container.

### getRemoteUser

    public String getRemoteUser()

  The default behavior of this method is to return getRemoteUser() on the wrapped request object.

  Specified by:
    `getRemoteUser` in interface `HttpServletRequest`
  Returns:
    a `String` specifying the login of the user making this request, or `null` if the user login is not known

### isUserInRole

    public boolean isUserInRole(String role)

  The default behavior of this method is to return isUserInRole(String role) on the wrapped request object.

  Specified by:
    `isUserInRole` in interface `HttpServletRequest`
  Parameters:
    `role` - a `String` specifying the name of the role
  Returns:
    a `boolean` indicating whether the user making this request belongs to a given role; `false` if the user has not been authenticated

### getUserPrincipal

    public Principal getUserPrincipal()

  The default behavior of this method is to return getUserPrincipal() on the wrapped request object.

  Specified by:
    `getUserPrincipal` in interface `HttpServletRequest`
  Returns:
    a `java.security.Principal` containing the name of the user making this request; `null` if the user has not been authenticated

### getRequestedSessionId

    public String getRequestedSessionId()

  The default behavior of this method is to return getRequestedSessionId() on the wrapped request object.

  Specified by:
    `getRequestedSessionId` in interface `HttpServletRequest`
  Returns:
    a `String` specifying the session ID, or `null` if the request did not specify a session ID
  See Also:
    `HttpServletRequest.isRequestedSessionIdValid()`

### getRequestURI

    public String getRequestURI()

  The default behavior of this method is to return getRequestURI() on the wrapped request object.

  Specified by:
    `getRequestURI` in interface `HttpServletRequest`
  Returns:
    a `String` containing the part of the URL from the protocol name up to the query string
  See Also:
    `HttpUtils.getRequestURL(javax.servlet.http.HttpServletRequest)`

### getRequestURL

    public StringBuffer getRequestURL()

  The default behavior of this method is to return getRequestURL() on the wrapped request object.

  Specified by:
    `getRequestURL` in interface `HttpServletRequest`
  Returns:
    a `StringBuffer` object containing the reconstructed URL

### getServletPath

    public String getServletPath()

  The default behavior of this method is to return getServletPath() on the wrapped request object.

  Specified by:
    `getServletPath` in interface `HttpServletRequest`
  Returns:
    a `String` containing the name or path of the servlet being called, as specified in the request URL, decoded, or an empty string if the servlet used to process the request is matched using the "/*" pattern.

### getSession

    public HttpSession getSession(boolean create)

  The default behavior of this method is to return getSession(boolean create) on the wrapped request object.

  Specified by:
    `getSession` in interface `HttpServletRequest`
  Parameters:
    `create` - `true` to create a new session for this request if necessary; `false` to return `null` if there's no current session
  Returns:
    the `HttpSession` associated with this request or `null` if `create` is `false` and the request has no valid session
  See Also:
    `HttpServletRequest.getSession()`

### getSession

    public HttpSession getSession()

  The default behavior of this method is to return getSession() on the wrapped request object.

  Specified by:
    `getSession` in interface `HttpServletRequest`
  Returns:
    the `HttpSession` associated with this request
  See Also:
    `HttpServletRequest.getSession(boolean)`

### isRequestedSessionIdValid

    public boolean isRequestedSessionIdValid()

  The default behavior of this method is to return isRequestedSessionIdValid() on the wrapped request object.

  Specified by:
    `isRequestedSessionIdValid` in interface `HttpServletRequest`
  Returns:
    `true` if this request has an id for a valid session in the current session context; `false` otherwise
  See Also:
    `HttpServletRequest.getRequestedSessionId()`, `HttpServletRequest.getSession(boolean)`, `HttpSessionContext`

### isRequestedSessionIdFromCookie

    public boolean isRequestedSessionIdFromCookie()

  The default behavior of this method is to return isRequestedSessionIdFromCookie() on the wrapped request object.

  Specified by:
    `isRequestedSessionIdFromCookie` in interface `HttpServletRequest`
  Returns:
    `true` if the session ID came in as a cookie; otherwise, `false`
  See Also:
    `HttpServletRequest.getSession(boolean)`

### isRequestedSessionIdFromURL

    public boolean isRequestedSessionIdFromURL()

  The default behavior of this method is to return isRequestedSessionIdFromURL() on the wrapped request object.

  Specified by:
    `isRequestedSessionIdFromURL` in interface `HttpServletRequest`
  Returns:
    `true` if the session ID came in as part of a URL; otherwise, `false`
  See Also:
    `HttpServletRequest.getSession(boolean)`

### isRequestedSessionIdFromUrl

    public boolean isRequestedSessionIdFromUrl()

  The default behavior of this method is to return isRequestedSessionIdFromUrl() on the wrapped request object.

  Specified by:
    `isRequestedSessionIdFromUrl` in interface `HttpServletRequest`

### authenticate

    public boolean authenticate(HttpServletResponse response)
                         throws IOException,
                                ServletException

  The default behavior of this method is to call authenticate on the wrapped request object.

  Specified by:
    `authenticate` in interface `HttpServletRequest`
  Parameters:
    `response` - The `HttpServletResponse` associated with this `HttpServletRequest`
  Returns:
    `true` when non-null values were or have been established as the values returned by `getUserPrincipal`, `getRemoteUser`, and `getAuthType`. Return `false` if authentication is incomplete and the underlying login mechanism has committed, in the response, the message (e.g., challenge) and HTTP status code to be returned to the user.
  Throws:
    `IOException` - if an input or output error occurred while reading from this request or writing to the given response
    `ServletException` - if the authentication failed and the caller is responsible for handling the error (i.e., the underlying login mechanism did NOT establish the message and HTTP status code to be returned to the user)
  Since:
    Servlet 3.0

### login

    public void login(String username,
                      String password)
               throws ServletException

  The default behavior of this method is to call login on the wrapped request object.

  Specified by:
    `login` in interface `HttpServletRequest`
  Parameters:
    `username` - The `String` value corresponding to the login identifier of the user.
    `password` - The password `String` corresponding to the identified user.
  Throws:
    `ServletException` - if the configured login mechanism does not support username password authentication, or if a non-null caller identity had already been established (prior to the call to login), or if validation of the provided username and password fails.
  Since:
    Servlet 3.0

### logout

    public void logout()
                throws ServletException

  The default behavior of this method is to call login on the wrapped request object.

  Specified by:
    `logout` in interface `HttpServletRequest`
  Throws:
    `ServletException` - if logout fails
  Since:
    Servlet 3.0

### getParts

    public Collection<Part> getParts()
                              throws IOException,
                                     ServletException

  The default behavior of this method is to call getParts on the wrapped request object.

  Any changes to the returned `Collection` must not affect this `HttpServletRequestWrapper`.

  Specified by:
    `getParts` in interface `HttpServletRequest`
  Returns:
    a (possibly empty) `Collection` of the Part components of this request
  Throws:
    `IOException` - if an I/O error occurred during the retrieval of the `Part` components of this request
    `ServletException` - if this request is not of type `multipart/form-data`
  Since:
    Servlet 3.0
  See Also:
    `MultipartConfig.maxFileSize()`, `MultipartConfig.maxRequestSize()`

### getPart

    public Part getPart(String name)
                 throws IOException,
                        ServletException

  The default behavior of this method is to call getPart on the wrapped request object.

  Specified by:
    `getPart` in interface `HttpServletRequest`
  Parameters:
    `name` - the name of the requested Part
  Returns:
    The Part with the given name, or `null` if this request is of type `multipart/form-data`, but does not contain the requested Part
  Throws:
    `IOException` - if an I/O error occurred during the retrieval of the requested Part
    `ServletException` - if this request is not of type `multipart/form-data`
  Since:
    Servlet 3.0
  See Also:
    `MultipartConfig.maxFileSize()`, `MultipartConfig.maxRequestSize()`

### upgrade

    public void upgrade(ProtocolHandler handler)
                 throws IOException

  Notifies the servlet container that the given ProtcolHandler would be used to upgrade the request.

  Specified by:
    `upgrade` in interface `HttpServletRequest`
  Parameters:
    `handler` - The `ProtocolHandler` used for the upgrade.
  Throws:
    `IOException` - if an I/O error occurred during the upgrade
  Since:
    Servlet 3.1
  See Also:
    `ProtocolHandler`, `WebConnection`

Copyright © 2012 GlassFish Community. All Rights Reserved.